// UI elements.
const deviceNameLabel = document.getElementById('device-name');
const connectButton = document.getElementById('connect');
const disconnectButton = document.getElementById('disconnect');
const terminalContainer = document.getElementById('terminal');
const sendForm = document.getElementById('send-form');
const inputField = document.getElementById('input');
// const happy = document.getElementById('happy');

var active = 'white';
var attribute = 'nothing';

// Helpers.
const defaultDeviceName = 'Terminal';
const terminalAutoScrollingLimit = terminalContainer.offsetHeight / 2;
let isTerminalAutoScrolling = true;

window.addEventListener("load",function() {
  addListeners();
});

const scrollElement = (element) => {
  const scrollTop = element.scrollHeight - element.offsetHeight;

  if (scrollTop > 0) {
    element.scrollTop = scrollTop;
  }
};

const logToTerminal = (message, type = '') => {
  terminalContainer.insertAdjacentHTML('beforeend',
      `<div${type && ` class="${type}"`}>${message}</div>`);

  if (isTerminalAutoScrolling) {
    scrollElement(terminalContainer);
  }
};

// Obtain configured instance.
let terminal = new BluetoothTerminal();

// Override `receive` method to log incoming data to the terminal.
terminal.receive = function(data) {
      console.log("hi");
  logToTerminal(data, 'in');
};

// Override default log method to output messages to the terminal and console.
terminal._log = function(...messages) {
  // We can't use `super._log()` here.
  messages.forEach((message) => {
    logToTerminal(message);
    console.log("here's the message", message); // eslint-disable-line no-console
  });
};

// Implement own send function to log outcoming data to the terminal.
const send = (data) => {
  terminal.send(data).
      then(() => logToTerminal(data, 'out')).
      catch((error) => logToTerminal(error));
};

// Bind event listeners to the UI elements.
connectButton.addEventListener('click', () => {
  terminal.connect().
      then(() => {
        deviceNameLabel.textContent = terminal.getDeviceName() ?
            terminal.getDeviceName() : defaultDeviceName;
      });
});

disconnectButton.addEventListener('click', () => {
  terminal.disconnect();
  deviceNameLabel.textContent = defaultDeviceName;
});

sendForm.addEventListener('submit', (event) => {
  event.preventDefault();

  send(inputField.value);
      console.log("hi");
  console.log(inputField.value);

  inputField.value = '';
  inputField.focus();
});

function addListeners() {
  var butts = document.getElementsByClassName("mood");
  for (var i = 0; i < butts.length; i++) {
    butts[i].addEventListener("click", function() {
      // console.log(this.getAttribute("id"));
      attribute = this.getAttribute("id");

      if (attribute !== active) {
        // console.log ("calling");
        this.style.color = attribute;
        active = attribute;
        // console.log (active, attribute)

        for (var i = 0; i < butts.length; i++) {
          // console.log(butts[i].id);
          if (butts[i].id !== active) {
            butts[i].style.color = 'black'
          }
        }

      }

      // else {
      //   this.style.color = "black";
      // }

      firstChar = attribute.charAt(0);
      console.log(firstChar);

      send(firstChar);

      })
    


  //     attribute = this.getAttribute("data-value")

  //     if (active ==! attribute) {
  //       active.style.color = black //reset to black
  //       active = attribute

  //           this.style.color = 'blue'
  //     }

  //     send(this.getAttribute("data-value"));
  //   });
  // }
}
}

// Switch terminal auto scrolling if it scrolls out of bottom.
terminalContainer.addEventListener('scroll', () => {
  const scrollTopOffset = terminalContainer.scrollHeight -
      terminalContainer.offsetHeight - terminalAutoScrollingLimit;

  isTerminalAutoScrolling = (scrollTopOffset < terminalContainer.scrollTop);
});
